diff --git a/ldap/servers/plugins/rootdn_access/rootdn_access.c b/ldap/servers/plugins/rootdn_access/rootdn_access.c
index 3450ce2..a8933f9 100644
--- a/ldap/servers/plugins/rootdn_access/rootdn_access.c
+++ b/ldap/servers/plugins/rootdn_access/rootdn_access.c
@@ -63,8 +63,8 @@ char * strToLower(char *str);
  */
 static void *_PluginID = NULL;
 static char *_PluginDN = NULL;
-static int open_time = 0;
-static int close_time = 0;
+static time_t open_time = 0;
+static time_t close_time = 0;
 static char *daysAllowed = NULL;
 static char **hosts = NULL;
 static char **hosts_to_deny = NULL;
@@ -289,7 +289,7 @@ rootdn_load_config(Slapi_PBlock *pb)
              */
             strncpy(hour, openTime,2);
             strncpy(min, openTime+2,2);
-            open_time = (atoi(hour) * 3600) + (atoi(min) * 60);
+            open_time = (time_t)(atoi(hour) * 3600) + (atoi(min) * 60);
         }
         if(closeTime){
             end = strspn(closeTime, "0123456789");
@@ -317,7 +317,7 @@ rootdn_load_config(Slapi_PBlock *pb)
              */
             strncpy(hour, closeTime,2);
             strncpy(min, closeTime+2,2);
-            close_time = (atoi(hour) * 3600) + (atoi(min) * 60);
+            close_time = (time_t)(atoi(hour) * 3600) + (atoi(min) * 60);
         }
         if((openTime && closeTime == NULL) || (openTime == NULL && closeTime)){
             /* If you are using TOD access control, you must have a open and close time */
@@ -461,16 +461,16 @@ rootdn_check_access(Slapi_PBlock *pb){
      *  grab the current time/info if we need it
      */
     if(open_time || daysAllowed){
-        time(&curr_time);
+        curr_time = slapi_current_utc_time();
         timeinfo = localtime(&curr_time);
     }
     /*
      *  First check TOD restrictions, continue through if we are in the open "window"
      */
     if(open_time){
-        int curr_total;
+        time_t curr_total;
 
-        curr_total = (timeinfo->tm_hour * 3600) + (timeinfo->tm_min * 60);
+        curr_total = (time_t)(timeinfo->tm_hour * 3600) + (timeinfo->tm_min * 60);
 
         if((curr_total < open_time) || (curr_total >= close_time)){
             slapi_log_err(SLAPI_LOG_PLUGIN, ROOTDN_PLUGIN_SUBSYSTEM, "rootdn_check_access - Bind not in the "
diff --git a/ldap/servers/plugins/syntaxes/string.c b/ldap/servers/plugins/syntaxes/string.c
index ac3d532..753a369 100644
--- a/ldap/servers/plugins/syntaxes/string.c
+++ b/ldap/servers/plugins/syntaxes/string.c
@@ -197,10 +197,7 @@ string_filter_sub( Slapi_PBlock *pb, char *initial, char **any, char *final,
 	size_t		tmpbufsize;
 	char		pat[BUFSIZ];
 	char		buf[BUFSIZ];
-	time_t		curtime = 0;
-	time_t		time_up = 0;
-	time_t		optime = 0; /* time op was initiated */
-	int		timelimit = 0; /* search timelimit */
+	struct timespec expire_time = {0};
 	Operation	*op = NULL;
 	Slapi_Regex	*re = NULL;
 	const char  *re_result = NULL;
@@ -214,17 +211,10 @@ string_filter_sub( Slapi_PBlock *pb, char *initial, char **any, char *final,
 		slapi_pblock_get( pb, SLAPI_OPERATION, &op );
 	}
 	if (NULL != op) {
+		int32_t timelimit = -1; /* search timelimit */
 		slapi_pblock_get( pb, SLAPI_SEARCH_TIMELIMIT, &timelimit );
-		slapi_pblock_get( pb, SLAPI_OPINITIATED_TIME, &optime );
-	} else {
-		/* timelimit is not passed via pblock */
-		timelimit = -1;
+		slapi_operation_time_expiry(op, (time_t)timelimit, &expire_time);
 	}
-	/*
-	 * (timelimit==-1) means no time limit
-	 */
-	time_up = ( timelimit==-1 ? -1 : optime + timelimit);
-
 	if (pb) {
 		slapi_pblock_get( pb, SLAPI_PLUGIN_SYNTAX_FILTER_NORMALIZED, &filter_normalized );
 		slapi_pblock_get( pb, SLAPI_PLUGIN_SYNTAX_FILTER_DATA, &sf );
@@ -335,8 +325,8 @@ string_filter_sub( Slapi_PBlock *pb, char *initial, char **any, char *final,
 		}
 	}
 
-	curtime = current_time();
-	if ( time_up != -1 && curtime > time_up ) {
+	if (slapi_timespec_expire_check(&expire_time) == TIMER_EXPIRED) {
+		slapi_log_err(SLAPI_LOG_TRACE, SYNTAX_PLUGIN_SUBSYSTEM, "LDAP_TIMELIMIT_EXCEEDED\n");
 		rc = LDAP_TIMELIMIT_EXCEEDED;
 		goto bailout;
 	}
@@ -371,10 +361,20 @@ string_filter_sub( Slapi_PBlock *pb, char *initial, char **any, char *final,
 			slapi_dn_ignore_case(realval);
 		}
 		if (alt) {
-			tmprc = slapi_re_exec( re, alt, time_up );
+			if (slapi_timespec_expire_check(&expire_time) == TIMER_EXPIRED) {
+				slapi_log_err(SLAPI_LOG_TRACE, SYNTAX_PLUGIN_SUBSYSTEM, "LDAP_TIMELIMIT_EXCEEDED\n");
+				rc = LDAP_TIMELIMIT_EXCEEDED;
+				goto bailout;
+			}
+			tmprc = slapi_re_exec_nt(re, alt);
 			slapi_ch_free_string(&alt);
 		} else {
-			tmprc = slapi_re_exec( re, realval, time_up );
+			if (slapi_timespec_expire_check(&expire_time) == TIMER_EXPIRED) {
+				slapi_log_err(SLAPI_LOG_TRACE, SYNTAX_PLUGIN_SUBSYSTEM, "LDAP_TIMELIMIT_EXCEEDED\n");
+				rc = LDAP_TIMELIMIT_EXCEEDED;
+				goto bailout;
+			}
+			tmprc = slapi_re_exec_nt(re, realval);
 		}
 
 		if (slapi_is_loglevel_set(SLAPI_LOG_TRACE)) {
diff --git a/ldap/servers/slapd/abandon.c b/ldap/servers/slapd/abandon.c
index 581b6d2..2abb96a 100644
--- a/ldap/servers/slapd/abandon.c
+++ b/ldap/servers/slapd/abandon.c
@@ -137,10 +137,12 @@ do_abandon( Slapi_PBlock *pb )
 			" targetop=SUPPRESSED-BY-PLUGIN msgid=%d\n",
 			pb_conn->c_connid, pb_op->o_opid, id );
 	} else {
+		struct timespec o_hr_time_end;
+		slapi_operation_time_elapsed(o, &o_hr_time_end);
 		slapi_log_access( LDAP_DEBUG_STATS, "conn=%" PRIu64 " op=%d ABANDON"
-			" targetop=%d msgid=%d nentries=%d etime=%ld\n",
+			" targetop=%d msgid=%d nentries=%d etime=%"PRId64".%010"PRId64"\n",
 			pb_conn->c_connid, pb_op->o_opid, o->o_opid, id,
-			o->o_results.r.r_search.nentries, current_time() - o->o_time );
+			o->o_results.r.r_search.nentries, o_hr_time_end.tv_sec, o_hr_time_end.tv_nsec);
 	}
 
 	PR_ExitMonitor(pb_conn->c_mutex);
diff --git a/ldap/servers/slapd/add.c b/ldap/servers/slapd/add.c
index 7fa5444..eb9a9fc 100644
--- a/ldap/servers/slapd/add.c
+++ b/ldap/servers/slapd/add.c
@@ -780,13 +780,11 @@ done:
 static int 
 add_created_attrs(Slapi_PBlock *pb, Slapi_Entry *e)
 {
-	char   buf[20];
+	char   buf[SLAPI_TIMESTAMP_BUFSIZE];
 	char   *binddn = NULL;
 	char   *plugin_dn = NULL;
 	struct berval	bv;
 	struct berval	*bvals[2];
-	time_t		curtime;
-	struct tm	ltm;
 	Operation *op;
 	struct slapdplugin *plugin = NULL;
 	struct slapi_componentid *cid = NULL;
@@ -848,9 +846,7 @@ add_created_attrs(Slapi_PBlock *pb, Slapi_Entry *e)
 	slapi_entry_attr_replace(e, "creatorsname", bvals);
 	slapi_entry_attr_replace(e, "modifiersname", bvals);
 
-	curtime = current_time();
-	gmtime_r(&curtime, &ltm);
-	strftime(buf, sizeof(buf), "%Y%m%d%H%M%SZ", &ltm);
+	slapi_timestamp_utc_hr(buf, SLAPI_TIMESTAMP_BUFSIZE);
 
 	bv.bv_val = buf;
 	bv.bv_len = strlen(bv.bv_val);
diff --git a/ldap/servers/slapd/auditlog.c b/ldap/servers/slapd/auditlog.c
index 59ba476..d065669 100644
--- a/ldap/servers/slapd/auditlog.c
+++ b/ldap/servers/slapd/auditlog.c
@@ -95,7 +95,7 @@ write_audit_log_entry( Slapi_PBlock *pb )
     default:
         return; /* Unsupported operation type. */
     }
-    curtime = current_time();
+    curtime = slapi_current_utc_time();
     /* log the raw, unnormalized DN */
     dn = slapi_sdn_get_udn(sdn);
     write_audit_file(SLAPD_AUDIT_LOG, operation_get_type(op), dn, change, flag, curtime, LDAP_SUCCESS, SLAPD_AUDIT_LOG);
@@ -164,7 +164,7 @@ write_auditfail_log_entry( Slapi_PBlock *pb )
     default:
         return; /* Unsupported operation type. */
     }
-    curtime = current_time();
+    curtime = slapi_current_utc_time();
     /* log the raw, unnormalized DN */
     dn = slapi_sdn_get_udn(sdn);
     auditfail_config = config_get_auditfaillog();
diff --git a/ldap/servers/slapd/back-ldbm/dblayer.c b/ldap/servers/slapd/back-ldbm/dblayer.c
index 3290052..8bcd4e2 100644
--- a/ldap/servers/slapd/back-ldbm/dblayer.c
+++ b/ldap/servers/slapd/back-ldbm/dblayer.c
@@ -4301,19 +4301,21 @@ dblayer_start_checkpoint_thread(struct ldbminfo *li)
  */
 static int checkpoint_threadmain(void *param)
 {
-    time_t time_of_last_checkpoint_completion = 0;    /* seconds since epoch */
     PRIntervalTime    interval;
     int rval = -1;
     dblayer_private *priv = NULL;
     struct ldbminfo *li = NULL;
     int debug_checkpointing = 0;
-    int checkpoint_interval;
     char *home_dir = NULL;
     char **list = NULL;
     char **listp = NULL;
     struct dblayer_private_env *penv = NULL;
-    time_t time_of_last_comapctdb_completion = current_time();    /* seconds since epoch */
-    int compactdb_interval = 0;
+    struct timespec checkpoint_expire;
+    struct timespec compactdb_expire;
+    time_t compactdb_interval_update = 0;
+    time_t checkpoint_interval_update = 0;
+    time_t compactdb_interval = 0;
+    time_t checkpoint_interval = 0;
     back_txn txn;
 
     PR_ASSERT(NULL != param);
@@ -4324,8 +4326,7 @@ static int checkpoint_threadmain(void *param)
 
     INCR_THREAD_COUNT(priv);
 
-    compactdb_interval = priv->dblayer_compactdb_interval;
-    interval = PR_MillisecondsToInterval(DBLAYER_SLEEP_INTERVAL);
+    interval = PR_MillisecondsToInterval(DBLAYER_SLEEP_INTERVAL * 10);
     home_dir = dblayer_get_home_dir(li, NULL);
     if (NULL == home_dir || '\0' == *home_dir)
     {
@@ -4337,76 +4338,113 @@ static int checkpoint_threadmain(void *param)
     /* work around a problem with newly created environments */
     dblayer_force_checkpoint(li);
 
+    PR_Lock(li->li_config_mutex);
+    checkpoint_interval = (time_t)priv->dblayer_checkpoint_interval;
+    compactdb_interval = (time_t)priv->dblayer_compactdb_interval;
     penv = priv->dblayer_env;
     debug_checkpointing = priv->db_debug_checkpointing;
+    PR_Unlock(li->li_config_mutex);
+
     /* assumes dblayer_force_checkpoint worked */
-    time_of_last_checkpoint_completion = current_time();
+    /*
+     * Importantly, the use of this api is not affected by backwards time steps
+     * and the like. Because this use relative system time, rather than utc,
+     * it makes it much more reliable to run.
+     */
+    slapi_timespec_expire_at(compactdb_interval, &compactdb_expire);
+    slapi_timespec_expire_at(checkpoint_interval, &checkpoint_expire);
+
     while (!priv->dblayer_stop_threads)
     {
         /* sleep for a while */
         /* why aren't we sleeping exactly the right amount of time ? */
         /* answer---because the interval might be changed after the server 
          * starts up */
+
         DS_Sleep(interval);
 
-        if (0 == priv->dblayer_enable_transactions) 
+        if (0 == priv->dblayer_enable_transactions) {
             continue;
+        }
 
         PR_Lock(li->li_config_mutex);
-        checkpoint_interval = priv->dblayer_checkpoint_interval;
+        checkpoint_interval_update = (time_t)priv->dblayer_checkpoint_interval;
+        compactdb_interval_update = (time_t)priv->dblayer_compactdb_interval;
         PR_Unlock(li->li_config_mutex);
 
-        /* Check to see if the checkpoint interval has elapsed */
-        if (current_time() - time_of_last_checkpoint_completion <
-                                               checkpoint_interval) 
-            continue;
+        /* If the checkpoint has been updated OR we have expired */
+        if (checkpoint_interval != checkpoint_interval_update &&
+            slapi_timespec_expire_check(&checkpoint_expire) == TIMER_EXPIRED) {
 
-        if (!dblayer_db_uses_transactions(priv->dblayer_env->dblayer_DB_ENV))
-            continue;
+            /* If our interval has changed, update it. */
+            checkpoint_interval = checkpoint_interval_update;
 
-        /* now checkpoint */
-        checkpoint_debug_message(debug_checkpointing,
-                                 "checkpoint_threadmain - Starting checkpoint\n");
-        rval = dblayer_txn_checkpoint(li, priv->dblayer_env, 
-                                      PR_TRUE, PR_FALSE);
-        checkpoint_debug_message(debug_checkpointing,
-                                 "checkpoint_threadmain - Checkpoint Done\n");
-        if (rval != 0) {
-            /* bad error */
-            slapi_log_err(SLAPI_LOG_CRIT,
-                "checkpoint_threadmain", "Serious Error---Failed to checkpoint database, "
-                "err=%d (%s)\n", rval, dblayer_strerror(rval));
-            if (LDBM_OS_ERR_IS_DISKFULL(rval)) {
-                operation_out_of_disk_space();
-                goto error_return;
+            if (!dblayer_db_uses_transactions(priv->dblayer_env->dblayer_DB_ENV)) {
+                continue;
             }
-        } else {
-            time_of_last_checkpoint_completion = current_time();
-        }
 
-        checkpoint_debug_message(debug_checkpointing,
-                                 "checkpoint_threadmain - Starting checkpoint\n");
-        rval = dblayer_txn_checkpoint(li, priv->dblayer_env, 
-                                      PR_TRUE, PR_FALSE);
-        checkpoint_debug_message(debug_checkpointing,
-                                 "checkpoint_threadmain - Checkpoint Done\n");
-        if (rval != 0) {
-            /* bad error */
-            slapi_log_err(SLAPI_LOG_CRIT,
-                "checkpoint_threadmain", "Serious Error---Failed to checkpoint database, "
-                "err=%d (%s)\n", rval, dblayer_strerror(rval));
-            if (LDBM_OS_ERR_IS_DISKFULL(rval)) {
-                operation_out_of_disk_space();
-                goto error_return;
+            /* now checkpoint */
+            checkpoint_debug_message(debug_checkpointing,
+                                     "checkpoint_threadmain - Starting checkpoint\n");
+            rval = dblayer_txn_checkpoint(li, priv->dblayer_env,
+                                          PR_TRUE, PR_FALSE);
+            checkpoint_debug_message(debug_checkpointing,
+                                     "checkpoint_threadmain - Checkpoint Done\n");
+            if (rval != 0) {
+                /* bad error */
+                slapi_log_err(SLAPI_LOG_CRIT,
+                    "checkpoint_threadmain", "Serious Error---Failed to checkpoint database, "
+                    "err=%d (%s)\n", rval, dblayer_strerror(rval));
+                if (LDBM_OS_ERR_IS_DISKFULL(rval)) {
+                    operation_out_of_disk_space();
+                    goto error_return;
+                }
             }
-        } else {
-            time_of_last_checkpoint_completion = current_time();
+
+            rval = LOG_ARCHIVE(penv->dblayer_DB_ENV, &list,
+                               DB_ARCH_ABS, (void *)slapi_ch_malloc);
+            if (rval) {
+                slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain",
+                               "log archive failed - %s (%d)\n", 
+                               dblayer_strerror(rval), rval);
+            } else {
+                for (listp = list; listp && *listp != NULL; ++listp) {
+                    if (priv->dblayer_circular_logging) {
+                        checkpoint_debug_message(debug_checkpointing,
+                                                 "Deleting %s\n", *listp);
+                        unlink(*listp);
+                    } else {
+                        char new_filename[MAXPATHLEN];
+                        PR_snprintf(new_filename, sizeof(new_filename),
+                                    "%s.old", *listp);
+                        checkpoint_debug_message(debug_checkpointing,
+                                    "Renaming %s -> %s\n",*listp, new_filename);
+                        if(rename(*listp, new_filename) != 0){
+                            slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain", "Failed to rename log (%s) to (%s)\n",
+                                    *listp, new_filename);
+                            rval = -1;
+                            goto error_return;
+                        }
+                    }
+                }
+                slapi_ch_free((void**)&list);
+                /* Note: references inside the returned memory need not be
+                 * individually freed. */
+            }
+            slapi_timespec_expire_at(checkpoint_interval, &checkpoint_expire);
         }
-        /* find out which log files don't contain active txns */
 
         /* Compacting DB borrowing the timing of the log flush */
-        if ((compactdb_interval > 0) &&
-            (current_time() - time_of_last_comapctdb_completion > compactdb_interval)) {
+
+        /*
+         * Remember that if compactdb_interval is 0, timer_expired can
+         * never occur unless the value in compctdb_interval changes.
+         *
+         * this could have been a bug infact, where compactdb_interval
+         * was 0, if you change while running it would never take effect ....
+         */
+        if (compactdb_interval_update != compactdb_interval ||
+            slapi_timespec_expire_check(&compactdb_expire) == TIMER_EXPIRED) {
             int rc = 0;
             Object *inst_obj;
             ldbm_instance *inst;
@@ -4422,17 +4460,45 @@ static int checkpoint_threadmain(void *param)
                 if (!db || rc ) {
                     continue;
                 }
-                slapi_log_err(SLAPI_LOG_BACKLDBM, "checkpoint_threadmain", "Compacting DB start: %s\n",
+                slapi_log_err(SLAPI_LOG_NOTICE, "checkpoint_threadmain", "Compacting DB start: %s\n",
                               inst->inst_name);
+
+                /*
+                 * It's possible for this to heap us after free because when we access db
+                 * *just* as the server shut's down, we don't know it. So we should probably
+                 * do something like wrapping access to the db var in a rwlock, and have "read"
+                 * to access, and take writes to change the state. This would prevent the issue.
+                 */
+                DBTYPE type;
+                rc = db->get_type(db, &type);
+                if (rc) {
+                    slapi_log_err(SLAPI_LOG_ERR,
+                              "compactdb: failed to determine db type for %s: db error - %d %s\n",
+                              inst->inst_name, rc, db_strerror(rc));
+                    continue;
+                }
+
                 rc = dblayer_txn_begin(inst->inst_be, NULL, &txn);
                 if (rc) {
                     slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain", "compactdb: transaction begin failed: %d\n", rc);
                     break;
                 }
+                /*
+                 * https://docs.oracle.com/cd/E17275_01/html/api_reference/C/BDB-C_APIReference.pdf
+                 * "DB_FREELIST_ONLY
+                 * Do no page compaction, only returning pages to the filesystem that are already free and at the end
+                 * of the file. This flag must be set if the database is a Hash access method database."
+                 *
+                 */
+
+                uint32_t compact_flags = DB_FREE_SPACE;
+                if (type == DB_HASH) {
+                    compact_flags |= DB_FREELIST_ONLY;
+                }
                 rc = db->compact(db, txn.back_txn_txn, NULL/*start*/, NULL/*stop*/, 
-                                 &c_data, DB_FREE_SPACE, NULL/*end*/);
+                                 &c_data, compact_flags, NULL/*end*/);
                 if (rc) {
-                    slapi_log_err(SLAPI_LOG_ERR,
+                    slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain",
                               "compactdb: failed to compact %s; db error - %d %s\n",
                               inst->inst_name, rc, db_strerror(rc));
                     if((rc = dblayer_txn_abort(inst->inst_be, &txn))){
@@ -4441,7 +4507,7 @@ static int checkpoint_threadmain(void *param)
                         break;
                     }
                 } else {
-                    slapi_log_err(SLAPI_LOG_BACKLDBM,
+                    slapi_log_err(SLAPI_LOG_NOTICE, "checkpoint_threadmain",
                                    "compactdb: compact %s - %d pages freed\n",
                                    inst->inst_name, c_data.compact_pages_free);
                     if((rc = dblayer_txn_commit(inst->inst_be, &txn))){
@@ -4451,40 +4517,10 @@ static int checkpoint_threadmain(void *param)
                     }
                 }
             }
-            time_of_last_comapctdb_completion = current_time();    /* seconds since epoch */
-            compactdb_interval = priv->dblayer_compactdb_interval;
+            compactdb_interval = compactdb_interval_update;
+            slapi_timespec_expire_at(compactdb_interval, &compactdb_expire);
         }
 
-        rval = LOG_ARCHIVE(penv->dblayer_DB_ENV, &list,
-                           DB_ARCH_ABS, (void *)slapi_ch_malloc);
-        if (rval) {
-            slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain",
-                           "log archive failed - %s (%d)\n", 
-                           dblayer_strerror(rval), rval);
-        } else {
-            for (listp = list; listp && *listp != NULL; ++listp) {
-                if (priv->dblayer_circular_logging) {
-                    checkpoint_debug_message(debug_checkpointing,
-                                             "Deleting %s\n", *listp);
-                    unlink(*listp);
-                } else {
-                    char new_filename[MAXPATHLEN];
-                    PR_snprintf(new_filename, sizeof(new_filename),
-                                "%s.old", *listp);
-                    checkpoint_debug_message(debug_checkpointing,
-                                "Renaming %s -> %s\n",*listp, new_filename);
-                    if(rename(*listp, new_filename) != 0){
-                        slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain", "Failed to rename log (%s) to (%s)\n",
-                                *listp, new_filename);
-                        rval = -1;
-                        goto error_return;
-                    }
-                }
-            }
-            slapi_ch_free((void**)&list);
-            /* Note: references inside the returned memory need not be 
-             * individually freed. */
-        }
     }
     slapi_log_err(SLAPI_LOG_TRACE, "checkpoint_threadmain", "Check point before leaving\n");
     rval = dblayer_force_checkpoint(li);
diff --git a/ldap/servers/slapd/back-ldbm/idl_new.c b/ldap/servers/slapd/back-ldbm/idl_new.c
index 1ffdc03..0c680aa 100644
--- a/ldap/servers/slapd/back-ldbm/idl_new.c
+++ b/ldap/servers/slapd/back-ldbm/idl_new.c
@@ -325,7 +325,7 @@ idl_new_range_fetch(
     int *flag_err,
     int allidslimit,
     int sizelimit,
-    time_t stoptime,
+    struct timespec *expire_time,
     int lookthrough_limit,
     int operator
 )
@@ -344,7 +344,6 @@ idl_new_range_fetch(
     DBT dataret;
     back_txn s_txn;
     struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
-    time_t curtime;
     void *saved_key = NULL;
     int coreop = operator & SLAPI_OP_RANGE;
     ID key = 0xff; /* random- to suppress compiler warning */
@@ -436,14 +435,15 @@ idl_new_range_fetch(
             }
         }
         /* timelimit check */
-        if (stoptime > 0) { /* timelimit is set */
-            curtime = current_time();
-            if (curtime >= stoptime) {
-                slapi_log_err(SLAPI_LOG_TRACE,
-                              "idl_new_range_fetch", "timelimit exceeded\n");
-                *flag_err = LDAP_TIMELIMIT_EXCEEDED;
-                goto error;
-            }
+        /*
+         * A future improvement could be to check this only every X iterations
+         * to prevent overwhelming the clock?
+         */
+        if (slapi_timespec_expire_check(expire_time) == TIMER_EXPIRED) {
+            slapi_log_err(SLAPI_LOG_TRACE,
+                          "idl_new_range_fetch", "timelimit exceeded\n");
+            *flag_err = LDAP_TIMELIMIT_EXCEEDED;
+            goto error;
         }
         if (operator & SLAPI_OP_RANGE_NO_IDL_SORT) {
             key = (ID)strtol((char *)cur_key.data+1 , (char **)NULL, 10);
diff --git a/ldap/servers/slapd/back-ldbm/import-merge.c b/ldap/servers/slapd/back-ldbm/import-merge.c
index b657507..385494d 100644
--- a/ldap/servers/slapd/back-ldbm/import-merge.c
+++ b/ldap/servers/slapd/back-ldbm/import-merge.c
@@ -647,7 +647,7 @@ int import_mega_merge(ImportJob *job)
                 passes, (long unsigned int)job->number_indexers);
     }
 
-    time(&beginning);
+    beginning = slapi_current_utc_time();
     /* Iterate over the files */
 	for (current_worker = job->worker_list; 
 	 (ret == 0) && (current_worker != NULL);
@@ -660,9 +660,9 @@ int import_mega_merge(ImportJob *job)
 			time_t file_end = 0;
 			int key_count = 0;
 	
-			time(&file_beginning);
+			file_beginning = slapi_current_utc_time();
 			ret = import_merge_one_file(current_worker,passes,&key_count);
-			time(&file_end);
+			file_end = slapi_current_utc_time();
 			if (key_count == 0) {
 				import_log_notice(job, SLAPI_LOG_INFO, "import_mega_merge", "No files to merge for \"%s\".",
 					current_worker->index_info->name);
@@ -679,12 +679,11 @@ int import_mega_merge(ImportJob *job)
 		}
 	}
 
-	time(&end);
+	end = slapi_current_utc_time();
 	if (0 == ret) {
 		int seconds_to_merge = end - beginning;
-	
-	import_log_notice(job, SLAPI_LOG_INFO, "import_mega_merge", "Merging completed in %d seconds.",
-			  seconds_to_merge);
+		import_log_notice(job, SLAPI_LOG_INFO, "import_mega_merge", "Merging completed in %d seconds.",
+				  seconds_to_merge);
 	}
 
     return ret;
diff --git a/ldap/servers/slapd/back-ldbm/import-threads.c b/ldap/servers/slapd/back-ldbm/import-threads.c
index c45a358..f2fe50d 100644
--- a/ldap/servers/slapd/back-ldbm/import-threads.c
+++ b/ldap/servers/slapd/back-ldbm/import-threads.c
@@ -295,11 +295,9 @@ import_get_version(char *str)
 static void
 import_add_created_attrs(Slapi_Entry *e)
 {
-    char          buf[20];
+    char          buf[SLAPI_TIMESTAMP_BUFSIZE];
     struct berval bv;
     struct berval *bvals[2];
-    time_t        curtime;
-    struct tm     ltm;
 
     bvals[0] = &bv;
     bvals[1] = NULL;
@@ -313,9 +311,7 @@ import_add_created_attrs(Slapi_Entry *e)
         slapi_entry_attr_replace(e, "modifiersname", bvals);
     }
 
-    curtime = current_time();
-    gmtime_r(&curtime, &ltm);
-    strftime(buf, sizeof(buf), "%Y%m%d%H%M%SZ", &ltm);
+    slapi_timestamp_utc_hr(buf, SLAPI_TIMESTAMP_BUFSIZE);
 
     bv.bv_val = buf;
     bv.bv_len = strlen(bv.bv_val);
diff --git a/ldap/servers/slapd/back-ldbm/import.c b/ldap/servers/slapd/back-ldbm/import.c
index 3839337..f035a71 100644
--- a/ldap/servers/slapd/back-ldbm/import.c
+++ b/ldap/servers/slapd/back-ldbm/import.c
@@ -761,7 +761,7 @@ static int import_monitor_threads(ImportJob *job, int *status)
         goto error_abort;
     }
 
-    time(&last_time);
+    last_time = slapi_current_utc_time();
     job->start_time = last_time;
     import_clear_progress_history(job);
 
@@ -773,7 +773,7 @@ static int import_monitor_threads(ImportJob *job, int *status)
 
         /* First calculate the time interval since last reported */
         if (0 == (count % display_interval)) {
-            time(&time_now);
+            time_now = slapi_current_utc_time();
             time_interval = time_now - last_time;
             last_time = time_now;
             /* Now calculate our rate of progress overall for this chunk */
@@ -1212,7 +1212,7 @@ int import_main_offline(void *arg)
         opstr = "Reindexing";
     }
     PR_ASSERT(inst != NULL);
-    time(&beginning);
+    beginning = slapi_current_utc_time();
 
     /* Decide which indexes are needed */
     if (job->flags & FLAG_INDEX_ATTRS) {
@@ -1496,7 +1496,7 @@ error:
     if (!(job->flags & FLAG_ONLINE))
         dblayer_close(job->inst->inst_li, DBLAYER_IMPORT_MODE);
     
-    time(&end);
+    end = slapi_current_utc_time();
     if (verbose && (0 == ret)) {
         int seconds_to_import = end - beginning;
         size_t entries_processed = job->lead_ID - (job->starting_ID - 1);
diff --git a/ldap/servers/slapd/back-ldbm/index.c b/ldap/servers/slapd/back-ldbm/index.c
index 4d74484..2ba82d2 100644
--- a/ldap/servers/slapd/back-ldbm/index.c
+++ b/ldap/servers/slapd/back-ldbm/index.c
@@ -1227,7 +1227,7 @@ index_range_read_ext(
     int lookthrough_limit = -1; /* default no limit */
     int is_and = 0;
     int sizelimit = 0;
-    time_t curtime, stoptime = 0;
+    struct timespec expire_time;
     int timelimit = -1;
     back_search_result_set *sr = NULL;
     int isroot = 0;
@@ -1252,11 +1252,9 @@ index_range_read_ext(
         slapi_pblock_get(pb, SLAPI_SEARCH_SIZELIMIT, &sizelimit);
     }
     slapi_pblock_get(pb, SLAPI_SEARCH_TIMELIMIT, &timelimit);
-    if (timelimit != -1) {
-        time_t optime;
-        slapi_pblock_get(pb, SLAPI_OPINITIATED_TIME, &optime);
-        stoptime = optime + timelimit;
-    }
+    Slapi_Operation        *op;
+    slapi_pblock_get( pb, SLAPI_OPERATION, &op );
+    slapi_operation_time_expiry(op, (time_t)timelimit, &expire_time);
 
     /*
      * Determine the lookthrough_limit from the PBlock.
@@ -1472,7 +1470,7 @@ index_range_read_ext(
     }
     if (idl_get_idl_new()) { /* new idl */
         idl = idl_new_range_fetch(be, db, &cur_key, &upperkey, db_txn,
-                                  ai, err, allidslimit, sizelimit, stoptime,
+                                  ai, err, allidslimit, sizelimit, &expire_time,
                                   lookthrough_limit, operator);
     } else { /* old idl */
         int retry_count = 0;
@@ -1509,14 +1507,11 @@ index_range_read_ext(
                 }
             }
             /* check time limit */
-            if (timelimit != -1) {
-                curtime = current_time();
-                if (curtime >= stoptime) {
-                    slapi_log_err(SLAPI_LOG_TRACE,
-                                   "index_range_read_ext", "timelimit exceeded\n");
-                    *err = LDAP_TIMELIMIT_EXCEEDED;
-                    break;
-                }
+            if (slapi_timespec_expire_check(&expire_time) == TIMER_EXPIRED) {
+                slapi_log_err(SLAPI_LOG_TRACE,
+                               "index_range_read_ext", "timelimit exceeded\n");
+                *err = LDAP_TIMELIMIT_EXCEEDED;
+                break;
             }
             /* Check to see if the operation has been abandoned (also happens
              * when the connection is closed by the client).
